/*
TECNISA - TECNOLOGIA EM INFORMTICA
@C:\web_625\sql\end_conv\sqlserver\5302_FISSTPO_Replicacao_Documentos.SQL
NOME: REPLICAO DE DOCUMENTOS FISCAIS
DESCRIO: PROCEDIMENTO PARA GERAO DE DOCUMENTOS FISCAIS
CRIAO: 30/09/99 - ROBERTO A. LOPES MARTINS
MANUTENES: 04/10/99 ROBERTO - INCLUSO DA SRIE NA TABELA DE TRABALHO(TRABREPLICDOC).
             25/11/99 ROBERT  - CONVERSO P/ SQL-SERVER
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE
              O.NAME = 'REPLICACAO_DOCUMENTOS' AND
              TYPE = 'P' 			              AND
              U.UID = O.UID             		  AND
              U.NAME = USER)

DROP PROCEDURE REPLICACAO_DOCUMENTOS
GO

CREATE PROCEDURE REPLICACAO_DOCUMENTOS @P_CDFILIAL    VARCHAR(04),
                                       @P_NRLANCTONF  VARCHAR(10),
                                       @P_CDFILIPROC  VARCHAR(04),
                                       @P_PRXNOTAFISC VARCHAR(10),
                                       @P_PRXLANCETSQ VARCHAR(10),
                                       @P_IDSISTEMA   VARCHAR(02) = 'DF',
                                       @P_IDDOCFATUR  VARCHAR(01) = NULL

AS

/* VARIVEIS DA TABELA DE NOTA FISCAL */
   DECLARE @V_CDEMPRESA      VARCHAR(02);
   DECLARE @V_CDEMPRAUX      VARCHAR(02);
   DECLARE @V_CDINSCESTA     VARCHAR(16);
   DECLARE @V_CDINSCMUNI     VARCHAR(16);
   DECLARE @V_CDFORNECED     VARCHAR(21);
   DECLARE @V_CDCLIENTE      VARCHAR(21);
   DECLARE @V_NRNOTAFISC     VARCHAR(20);
   DECLARE @V_DTEMISSAO      DATETIME;
   DECLARE @V_DTENTRSAID     DATETIME;
   DECLARE @V_VRPRODUTOS     NUMERIC(15,6);
   DECLARE @V_VRNOTAFISC     NUMERIC(15,6);
   DECLARE @V_NRPLACAVEIC    VARCHAR(07);
   DECLARE @V_SGUFVEIC       VARCHAR(02);
   DECLARE @V_IDPGTOFRETE    VARCHAR(01);
   DECLARE @V_DSQTDEVOLU     VARCHAR(06);
   DECLARE @V_DSESPECVOLU    VARCHAR(10);
   DECLARE @V_DSMARCAVOLU    VARCHAR(10);
   DECLARE @V_DSNUMEVOLU     VARCHAR(15);
   DECLARE @V_VRPBRUTOVOLU   NUMERIC(15,6);
   DECLARE @V_VRPLIQUVOLU    NUMERIC(15,6);
   DECLARE @V_IDENTRSAIDOP   VARCHAR(01);
   DECLARE @V_CDTIPOOPER     VARCHAR(02);
   DECLARE @V_CDSERIE        VARCHAR(05);
   DECLARE @V_CDSERIEAUX     VARCHAR(05);
   DECLARE @V_IDTPIJURTRAN   VARCHAR(01);
   DECLARE @V_NRINSJURTRAN   VARCHAR(20);
   DECLARE @V_CDSERIEENTR    VARCHAR(05);
   DECLARE @V_CDSERIEENTRAUX VARCHAR(05);
   DECLARE @V_CDFILIRECE     VARCHAR(04);
   DECLARE @V_CDMODDOCFISC   VARCHAR(02);
   

/* VARIVEIS DA TABELA DE TEMS DA NOTA FISCAL */
   DECLARE @V_NRSEQITPROD    VARCHAR(04);
   DECLARE @V_CDPRODUTO      VARCHAR(10);
   DECLARE @V_CDPRODEMIS     VARCHAR(20);
   DECLARE @V_DSPRODEMIS     VARCHAR(400);
   DECLARE @V_QTITEMPROD     NUMERIC(15,6);
   DECLARE @V_VRUNITITEM     NUMERIC(15,6);
   DECLARE @V_VRDESCITEM     NUMERIC(15,6);
   DECLARE @V_VRTOTAITEM     NUMERIC(15,6);
   DECLARE @V_VRCONTITEM     NUMERIC(15,6);
   DECLARE @V_VRBRUTITEM     NUMERIC(15,6);
   DECLARE @V_VRLIQUITEM     NUMERIC(15,6);

/* VARIVEIS DA TABELA DE IMPOSTOS DOS ITENS */
   DECLARE @V_CDIMPOSTO      VARCHAR(02);
   DECLARE @V_VRALIQITEM     NUMERIC(15,6);
   DECLARE @V_VRIMPOSTOIT    NUMERIC(15,6);
   DECLARE @V_VRPERREDBCIT   NUMERIC(15,6); 
   DECLARE @V_CDIMPOSTONFE   VARCHAR(02);

/* VARIVEIS DA TABELA DE TOTALIZAO DE IMPOSTOS */
   DECLARE @V_VRTOTIMPONF    NUMERIC(15,6);

/* VARIVEIS DA TABELA DE ENCARGOS */
   DECLARE @V_CDENCARGO      VARCHAR(02);
   DECLARE @V_VRITEMENCA     NUMERIC(15,6);

/* VARIVEIS DA TABELA DE ENCARGOS */
   DECLARE @V_NRDADOADIC     VARCHAR(03);
   DECLARE @V_CDMENSAGEM     VARCHAR(03); 
   DECLARE @V_DSDADOADIC     VARCHAR(255);

/* VARIVEIS DA TABELA DE REPLICAO DE DOCUMENTOS */
   DECLARE @V_CDFILIORIGTRD  VARCHAR(04);
   DECLARE @V_CDFILIDESTTRD  VARCHAR(04);
   DECLARE @V_IDENTRSAIDTRD  VARCHAR(01);
   DECLARE @V_CDTIPOOPERTRD  VARCHAR(02);
   DECLARE @V_CDSERIETRD     VARCHAR(05);
   DECLARE @V_CDALMOXARTRD   VARCHAR(06);
   DECLARE @V_CDLOCESTQTRD   VARCHAR(06);
   DECLARE @V_NRLOTEESTQ     VARCHAR(20);
   DECLARE @V_NRSUBLOTE      VARCHAR(04);

   DECLARE @V_ALMOXARIFE     VARCHAR(06);
   DECLARE @V_LOCALESTOQ     VARCHAR(06);
   DECLARE @V_IDCTRLESTQ     VARCHAR(01);
   DECLARE @V_IDUTILLOTE     VARCHAR(01);
   DECLARE @V_DSNUMELOTE     VARCHAR(50);

   DECLARE @V_IDATUESTTPOP   VARCHAR(01);

   DECLARE @V_PRXNRLANCNF    VARCHAR(10);
   DECLARE @V_PRXNRLANCEST   VARCHAR(10);
   DECLARE @V_IDTPIJURFILI   VARCHAR(01);
   DECLARE @V_NRINSJURFILI   VARCHAR(20);
   DECLARE @V_VRLANCAMENTO   NUMERIC(15,6);

   DECLARE @V_CDALMOXARIFE   VARCHAR(06);
   DECLARE @V_CDLOCALESTOQ   VARCHAR(06);
   DECLARE @V_CDFILIALDEL    VARCHAR(04);
   DECLARE @V_NRLANCTONFDEL  VARCHAR(10);
   DECLARE @V_IDEMPDESTREPAUT VARCHAR(01);
   DECLARE @V_IDCNTRESTOQ    VARCHAR(01);
   DECLARE @V_IDFUNCAOFILI   VARCHAR(01);
   DECLARE @V_REPLICACAOOK   INTEGER;
   DECLARE @V_SUGREGSTENTR   VARCHAR(01);
   DECLARE @V_CDENCARGOST    VARCHAR(02);
   DECLARE @V_T_VRIMPICMSST  NUMERIC(15,6);
   DECLARE @V_IDPERREPLICNFOL VARCHAR(01);
   DECLARE @V_IDPERREPLICNFOLAUX VARCHAR(01);

   DECLARE @V_DTVALILOTE     DATETIME;
   DECLARE @V_DTFABRPROD     DATETIME;
   DECLARE @V_NRLOTEFORN     VARCHAR(20);
BEGIN
   SET @V_CDSERIEAUX     = NULL;
   SET @V_CDSERIEENTRAUX = NULL;
   SET @V_IDTPIJURFILI   = NULL;
   SET @V_NRINSJURFILI   = NULL;
   SET @V_CDEMPRESA      = NULL;
   SET @V_CDINSCESTA     = NULL;
   SET @V_CDINSCMUNI     = NULL;
   SET @V_CDSERIEENTR    = NULL;
   SET @V_IDCTRLESTQ     = NULL;
   SET @V_CDENCARGOST    = NULL;
   SET @V_T_VRIMPICMSST  = 0;

   SELECT @V_IDEMPDESTREPAUT = ISNULL(IDEMPDESTREPAUT, 'N'),
          @V_IDPERREPLICNFOL = ISNULL(IDPERREPLICNFOL, 'N')
     FROM PARAMGERAL;

   DELETE FROM ITEMPRODUTO
    WHERE (CDFILIAL+NRLANCTONF) IN (SELECT CDFILIAL+NRLANCTONF
                                      FROM NOTAFISCAL
                                     WHERE IDDOCREPLIC = @P_CDFILIAL+@P_NRLANCTONF 
                                       AND IDDOCREPLIC <> CDFILIAL+NRLANCTONF       
                                       AND IDBLOQUEADO <> 'S');

   DELETE FROM CONTARECEBER
    WHERE (CDFILIAL+NRLANCTONF) IN (SELECT CDFILIAL+NRLANCTONF
                                      FROM NOTAFISCAL
                                     WHERE IDDOCREPLIC = @P_CDFILIAL+@P_NRLANCTONF 
                                       AND IDDOCREPLIC <> CDFILIAL+NRLANCTONF       
                                       AND IDBLOQUEADO <> 'S');

   DELETE FROM CONTAPAGAR
    WHERE (CDFILIAL+NRLANCTONF) IN (SELECT CDFILIAL+NRLANCTONF
                                      FROM NOTAFISCAL
                                     WHERE IDDOCREPLIC = @P_CDFILIAL+@P_NRLANCTONF 
                                       AND IDDOCREPLIC <> CDFILIAL+NRLANCTONF       
                                       AND IDBLOQUEADO <> 'S');

   DECLARE CURS_NF CURSOR FOR
   SELECT CDFILIAL, NRLANCTONF
     FROM NOTAFISCAL
    WHERE IDDOCREPLIC =  @P_CDFILIAL + @P_NRLANCTONF AND
          IDDOCREPLIC <> CDFILIAL + NRLANCTONF       AND
          IDBLOQUEADO <> 'S';

   OPEN CURS_NF;
   FETCH NEXT FROM CURS_NF INTO @V_CDFILIALDEL, @V_NRLANCTONFDEL;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      EXEC DELETA_NF @V_CDFILIALDEL, @V_NRLANCTONFDEL;
      FETCH NEXT FROM CURS_NF INTO @V_CDFILIALDEL, @V_NRLANCTONFDEL;
   END;
   CLOSE CURS_NF;
   DEALLOCATE CURS_NF;

   SET @V_PRXNRLANCNF  = @P_PRXNOTAFISC;
   SET @V_PRXNRLANCEST = @P_PRXLANCETSQ;
   SET @V_REPLICACAOOK = 0;

   DECLARE C_NOTAFISCAL1 CURSOR FOR
   SELECT CDEMPRESA,   CDINSCESTA, CDINSCMUNI,   CDFORNECED,   CDCLIENTE,
          NRNOTAFISC,  DTEMISSAO,  DTENTRSAID,   VRPRODUTOS,   VRNOTAFISC,
          NRPLACAVEIC, SGUFVEIC,   IDPGTOFRETE,  DSQTDEVOLU,   DSESPECVOLU,
          DSMARCAVOLU, DSNUMEVOLU, VRPBRUTOVOLU, VRPLIQUVOLU,  IDENTRSAIDOP,
          CDTIPOOPER,  CDSERIE,    IDTPIJURTRAN, NRINSJURTRAN, CDSERIEENTR,
          CDFILIRECE, CDMODDOCFISC
   FROM  NOTAFISCAL
   WHERE CDFILIAL   = @P_CDFILIAL AND
         NRLANCTONF = @P_NRLANCTONF;

   OPEN C_NOTAFISCAL1;

   FETCH NEXT FROM C_NOTAFISCAL1 INTO @V_CDEMPRAUX,   @V_CDINSCESTA,   @V_CDINSCMUNI,   @V_CDFORNECED,
                                      @V_CDCLIENTE,   @V_NRNOTAFISC,   @V_DTEMISSAO,    @V_DTENTRSAID,
                                      @V_VRPRODUTOS,  @V_VRNOTAFISC,   @V_NRPLACAVEIC,  @V_SGUFVEIC,
                                      @V_IDPGTOFRETE, @V_DSQTDEVOLU,   @V_DSESPECVOLU,  @V_DSMARCAVOLU,
                                      @V_DSNUMEVOLU,  @V_VRPBRUTOVOLU, @V_VRPLIQUVOLU,  @V_IDENTRSAIDOP,
                                      @V_CDTIPOOPER,  @V_CDSERIE,      @V_IDTPIJURTRAN, @V_NRINSJURTRAN,
                                      @V_CDSERIEENTR, @V_CDFILIRECE,   @V_CDMODDOCFISC;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      DECLARE C_TRABREPLICDOC CURSOR FOR
      SELECT CDFILIORIGTRD, CDFILIDESTTRD, IDENTRSAIDTRD,
             CDTIPOOPERTRD, CDSERIETRD,    CDALMOXARTRD,
             CDLOCESTQTRD
      FROM TRABREPLICDOC
      WHERE CDFILIALTRD   = @P_CDFILIAL AND
            NRLANCTONFTRD = @P_NRLANCTONF
      ORDER BY IDENTRSAIDTRD DESC;

      OPEN C_TRABREPLICDOC;

      FETCH NEXT FROM C_TRABREPLICDOC INTO @V_CDFILIORIGTRD, @V_CDFILIDESTTRD,
                                           @V_IDENTRSAIDTRD, @V_CDTIPOOPERTRD,
                                           @V_CDSERIETRD, @V_CDALMOXARTRD, @V_CDLOCESTQTRD;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         SELECT @V_CDMODDOCFISC = MIN(MT.CDMODDOCFISC)
           FROM MODDOCFISCTPOP MT
          WHERE MT.IDENTRSAIDOP = @V_IDENTRSAIDTRD
            AND MT.CDTIPOOPER   = @V_CDTIPOOPERTRD
            AND MT.CDMODDOCFISC = @V_CDMODDOCFISC;

         IF (@V_CDMODDOCFISC IS NULL) BEGIN
            SELECT @V_CDMODDOCFISC = MIN(MT.CDMODDOCFISC)
              FROM MODDOCFISCTPOP MT
             WHERE MT.IDENTRSAIDOP = @V_IDENTRSAIDTRD
               AND MT.CDTIPOOPER   = @V_CDTIPOOPERTRD;
         END;

         SELECT @V_IDFUNCAOFILI = ISNULL(MAX(IDFUNCAOFILI), 'X')
           FROM FILIAL
          WHERE CDFILIAL =  @V_CDFILIDESTTRD;

         SET @V_IDPERREPLICNFOLAUX = 'S';
         IF @V_IDFUNCAOFILI = 'O' BEGIN
            IF @V_IDPERREPLICNFOL <> 'S' BEGIN
               SET @V_IDPERREPLICNFOLAUX = 'N';
            END;
         END;

         IF (((@V_IDENTRSAIDTRD = 'E') AND (@V_IDPERREPLICNFOLAUX = 'S')) OR (@V_IDENTRSAIDTRD = 'S')) BEGIN
            SELECT @V_CDMODDOCFISC = MIN(MT.CDMODDOCFISC)
              FROM MODDOCFISCTPOP MT
             WHERE MT.IDENTRSAIDOP = @V_IDENTRSAIDTRD
               AND MT.CDTIPOOPER   = @V_CDTIPOOPERTRD
               AND MT.CDMODDOCFISC = @V_CDMODDOCFISC;

            IF (@V_CDMODDOCFISC IS NULL) BEGIN
               SELECT @V_CDMODDOCFISC = MIN(MT.CDMODDOCFISC)
                 FROM MODDOCFISCTPOP MT
                WHERE MT.IDENTRSAIDOP = @V_IDENTRSAIDTRD
                  AND MT.CDTIPOOPER   = @V_CDTIPOOPERTRD;
            END;

            IF @V_IDEMPDESTREPAUT = 'S' AND @V_IDENTRSAIDTRD = 'E' BEGIN
               SELECT @V_IDTPIJURFILI = MAX(IDTPIJURFILI),
                      @V_NRINSJURFILI = MAX(NRINSJURFILI),
                      @V_CDEMPRESA    = MAX(CDEMPRESA),
                      @V_CDINSCESTA   = MAX(CDINSCESTA),
                      @V_CDINSCMUNI   = MAX(CDINSCMUNI)
               FROM FILIAL
               WHERE (CDFILIAL = @V_CDFILIDESTTRD);
            END
            ELSE BEGIN
               SELECT @V_IDTPIJURFILI = MAX(IDTPIJURFILI),
                      @V_NRINSJURFILI = MAX(NRINSJURFILI)
               FROM FILIAL
               WHERE (CDFILIAL = @V_CDFILIORIGTRD AND @V_IDENTRSAIDTRD = 'E') OR
                     (CDFILIAL = @V_CDFILIDESTTRD AND @V_IDENTRSAIDTRD = 'S');

               /*Verifica a inscrio inicialmente para a empresa do lanamento*/
               SELECT @V_CDEMPRESA  = MAX(CDEMPRESA),
                      @V_CDINSCESTA = MAX(CDINSCESTA),
                      @V_CDINSCMUNI = MAX(CDINSCMUNI)
               FROM FILIAL
               WHERE ((CDFILIAL  = @V_CDFILIORIGTRD AND @V_IDENTRSAIDTRD = 'S')  OR
                      (CDFILIAL  = @V_CDFILIDESTTRD AND @V_IDENTRSAIDTRD = 'E')) AND
                     (CDEMPRESA  = @V_CDEMPRAUX);

               /*Se a empresa da filial for diferente verifica a incrio para a empresa relacionada*/
               IF @V_CDEMPRESA IS NULL BEGIN
                  SELECT @V_CDEMPRESA  = MAX(CDEMPRESA),
                         @V_CDINSCESTA = MAX(CDINSCESTA),
                         @V_CDINSCMUNI = MAX(CDINSCMUNI)
                  FROM EMPRCNTRFIL
                  WHERE ((CDFILIAL  = @V_CDFILIORIGTRD AND @V_IDENTRSAIDTRD = 'S')  OR
                         (CDFILIAL  = @V_CDFILIDESTTRD AND @V_IDENTRSAIDTRD = 'E')) AND
                        (CDEMPRESA  = @V_CDEMPRAUX);
               END;

               /*Caso no possua inscrio para a empresa da NF ele considera a inscrio da filial*/
               IF @V_CDEMPRESA IS NULL BEGIN
                  SELECT @V_CDEMPRESA  = MAX(CDEMPRESA),
                         @V_CDINSCESTA = MAX(CDINSCESTA),
                         @V_CDINSCMUNI = MAX(CDINSCMUNI)
                  FROM FILIAL
                  WHERE (CDFILIAL  = @V_CDFILIORIGTRD AND @V_IDENTRSAIDTRD = 'S') OR
                        (CDFILIAL  = @V_CDFILIDESTTRD AND @V_IDENTRSAIDTRD = 'E');
               END;
            END;

            IF (@V_IDENTRSAIDTRD = 'E') BEGIN
               SET @V_VRLANCAMENTO = @V_VRNOTAFISC;
               IF (@V_CDSERIEENTR IS NULL) AND (@V_CDSERIETRD  IS NOT NULL) BEGIN
                  SET @V_CDSERIEENTRAUX = @V_CDSERIETRD;
               END;

               IF (@V_CDSERIEENTRAUX IS NULL) BEGIN
                  SELECT @V_CDSERIEENTRAUX = MAX(CDSERIEENTR)
                    FROM SERIEENTR
                   WHERE CDSERIEENTR = @V_CDSERIE;
               END;

               SET @V_CDSERIEAUX = NULL;
               SET @V_DTEMISSAO  = @V_DTENTRSAID;
            END
            ELSE BEGIN
               SET @V_VRLANCAMENTO   = 0;
               SET @V_CDSERIEAUX     = @V_CDSERIETRD;
               SET @V_DTEMISSAO      = NULL;
               SET @V_NRNOTAFISC     = NULL;
               SET @V_CDSERIEENTRAUX = NULL;
            END;

            INSERT INTO NOTAFISCAL
               (CDFILIAL,    NRLANCTONF,   CDEMPRESA,    CDINSCESTA,   CDINSCMUNI,
                CDFILIEMIT,  CDFILIRECE,   IDTPIJURNF,   NRINSJURNF,   IDBLOQUEADO,
                DTEMISSAO,   DTENTRSAID,   VRPRODUTOS,   VRNOTAFISC,   NRPLACAVEIC,
                SGUFVEIC,    IDPGTOFRETE,  DSQTDEVOLU,   DSESPECVOLU,  DSMARCAVOLU,
                DSNUMEVOLU,  VRPBRUTOVOLU, VRPLIQUVOLU,  IDENTRSAIDOP, CDTIPOOPER,
                CDSERIE,     IDTPIJURTRAN, NRINSJURTRAN, IDSTATUS,     IDSISTEMA,
                CDSERIEENTR, IDDOCREPLIC, IDORIGDESTNF,  NRNOTAFISC,   CDMODDOCFISC,
                DTLANCAMENNF, IDDOCFATUR)
            VALUES
               (@P_CDFILIPROC, @V_PRXNRLANCNF, @V_CDEMPRESA, @V_CDINSCESTA, @V_CDINSCMUNI,
                @V_CDFILIORIGTRD, @V_CDFILIDESTTRD, @V_IDTPIJURFILI, @V_NRINSJURFILI, 'N',
                @V_DTEMISSAO, @V_DTENTRSAID, @V_VRPRODUTOS, @V_VRLANCAMENTO, @V_NRPLACAVEIC,
                @V_SGUFVEIC, @V_IDPGTOFRETE, @V_DSQTDEVOLU, @V_DSESPECVOLU, @V_DSMARCAVOLU,
                @V_DSNUMEVOLU, @V_VRPBRUTOVOLU, @V_VRPLIQUVOLU, @V_IDENTRSAIDTRD, @V_CDTIPOOPERTRD,
                @V_CDSERIEAUX, @V_IDTPIJURTRAN, @V_NRINSJURTRAN, 'P', 'DF' + @V_IDENTRSAIDTRD,
                @V_CDSERIEENTRAUX, @P_CDFILIAL + @P_NRLANCTONF, 'L', @V_NRNOTAFISC, @V_CDMODDOCFISC,
                @V_DTENTRSAID, @P_IDDOCFATUR);

            IF @V_IDENTRSAIDTRD = 'E' BEGIN

               DECLARE C_ITEMPRODUTOENTRADA CURSOR FOR
               SELECT I.NRSEQITPROD, I.CDPRODUTO,  I.CDPRODEMIS, I.DSPRODEMIS, I.QTITEMPROD,
                      I.VRUNITITEM,  I.VRDESCITEM, I.VRTOTAITEM, I.VRCONTITEM, I.VRBRUTITEM,
                      (I.VRTOTAITEM - I.VRDESCITEM) AS VRLIQUITEM, ISNULL(I.NRLOTEESTQ, ' ') NRLOTEESTQ, ISNULL(I.NRSUBLOTE, ' ') NRSUBLOTE,
                      L.DTVALILOTE, L.DTFABRPROD, L.NRLOTEFORN
                 FROM ITEMPRODUTO I LEFT JOIN LOTE L ON (I.CDFILIMOVI = L.CDFILIAL)   AND
                                                        (I.NRLOTEESTQ = L.NRLOTEESTQ) AND
                                                        (I.NRSUBLOTE  = L.NRSUBLOTE)  AND
                                                        (I.CDPRODMOVI = L.CDPRODUTO)
                WHERE I.CDFILIAL   = @P_CDFILIAL
                  AND I.NRLANCTONF = @P_NRLANCTONF
                ORDER BY I.NRSEQITPROD;
               OPEN C_ITEMPRODUTOENTRADA;

               FETCH NEXT FROM C_ITEMPRODUTOENTRADA INTO
               @V_NRSEQITPROD, @V_CDPRODUTO,  @V_CDPRODEMIS, @V_DSPRODEMIS,
               @V_QTITEMPROD,  @V_VRUNITITEM, @V_VRDESCITEM, @V_VRTOTAITEM,
               @V_VRCONTITEM,  @V_VRBRUTITEM, @V_VRLIQUITEM, @V_NRLOTEESTQ,
               @V_NRSUBLOTE,   @V_DTVALILOTE, @V_DTFABRPROD, @V_NRLOTEFORN;

               WHILE (@@FETCH_STATUS = 0) BEGIN

                  SELECT @V_IDCTRLESTQ = ISNULL(MAX(IDCTRLESTQ),'S'),
                         @V_IDUTILLOTE = ISNULL(MAX(IDUTILLOTE), 'N'),
                         @V_DSNUMELOTE =  MAX(DSNUMELOTE)
                  FROM PARAMFILIAL
                  WHERE CDFILIAL = @V_CDFILIDESTTRD;

                  SELECT @V_IDATUESTTPOP = ISNULL(IDATUESTTPOP, 'S')
                    FROM TIPOOPERAC
                   WHERE CDTIPOOPER   = @V_CDTIPOOPERTRD
                     AND IDENTRSAIDOP = @V_IDENTRSAIDTRD;

                  IF @V_IDUTILLOTE = 'S' BEGIN
                     SELECT @V_IDCNTRESTOQ = ISNULL(MAX(IDCNTRESTOQ), 'S'),
                            @V_IDUTILLOTE  = ISNULL(MAX(IDUTCTRLLOTE), 'S')
                       FROM PRODFILI
                      WHERE CDFILIAL  = @V_CDFILIDESTTRD
                        AND CDPRODUTO = @V_CDPRODUTO;
                  END
                  ELSE BEGIN
                     SELECT @V_IDCNTRESTOQ = ISNULL(MAX(IDCNTRESTOQ), 'S'),
                            @V_IDUTILLOTE = 'N'
                       FROM PRODFILI
                      WHERE CDFILIAL  = @V_CDFILIDESTTRD
                        AND CDPRODUTO = @V_CDPRODUTO;
                  END;

                  SELECT @V_IDCNTRESTOQ = ISNULL(MAX(IDCNTRESTOQ), 'S')
                    FROM PRODFILI
                   WHERE CDFILIAL  = @V_CDFILIDESTTRD
                     AND CDPRODUTO = @V_CDPRODUTO;

                  IF @V_IDCTRLESTQ = 'S' AND @V_IDATUESTTPOP = 'S' AND @V_IDCNTRESTOQ = 'S' BEGIN
                     EXEC LOCALESTOQUE_PADRAO @V_CDFILIDESTTRD, @V_CDPRODUTO, @P_CDALMOXARIFE = @V_CDALMOXARIFE OUTPUT, @P_CDLOCALESTOQ = @V_CDLOCALESTOQ OUTPUT;

                     IF (@V_CDALMOXARTRD = 'P') BEGIN
                        SET @V_ALMOXARIFE = @V_CDALMOXARIFE;
                     END
                     ELSE BEGIN
                        SET @V_ALMOXARIFE = @V_CDALMOXARTRD;
                     END;

                     IF (@V_CDLOCESTQTRD = 'P') BEGIN
                        SET @V_LOCALESTOQ = @V_CDLOCALESTOQ;
                     END
                     ELSE BEGIN
                        SET @V_LOCALESTOQ = @V_CDLOCESTQTRD;
                     END;

                     IF (@V_IDUTILLOTE = 'S') BEGIN
                        IF (@V_NRLOTEESTQ IS NULL) OR (@V_NRLOTEESTQ = ' ') BEGIN
                           EXEC PRXLOTEPRODEST @V_CDFILIDESTTRD, @V_DTENTRSAID, @V_CDPRODUTO, @V_NRLOTEESTQ OUTPUT;
                        END;

                        IF @V_NRLOTEESTQ IS NULL BEGIN
                           RAISERROR('REPLIC_BLOQ - OPERAO BLOQUEADA! NO FOI POSSVEL GERAR LOTE. FAVOR VERIFICAR OS PARMETROS DE CONTROLE DE LOTE.', 16,1);
                        END;
                     END
                     ELSE BEGIN
                        SET @V_NRLOTEESTQ = ' ';
                        SET @V_NRSUBLOTE  = ' ';
                     END;

                     INSERT INTO LOTE
                     (CDFILIAL, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO, IDSTATLOTE, DTENTRLOTE)
                     (SELECT @V_CDFILIDESTTRD, @V_NRLOTEESTQ, @V_NRSUBLOTE,
                             @V_CDPRODUTO, 'L', GETDATE()
                      FROM PARAMGERAL
                      WHERE
                      NOT EXISTS
                      (SELECT CDFILIAL, NRLOTEESTQ, NRSUBLOTE,
                             @V_CDPRODUTO, 'L', GETDATE()
                      FROM LOTE
                      WHERE  CDFILIAL   = @V_CDFILIDESTTRD AND
                             NRLOTEESTQ = @V_NRLOTEESTQ    AND
                             NRSUBLOTE  = @V_NRSUBLOTE     AND
                             CDPRODUTO  = @V_CDPRODUTO));

                     IF @V_NRLOTEESTQ <> ' ' BEGIN
                        UPDATE LOTE
                           SET DTVALILOTE = @V_DTVALILOTE,
                               DTFABRPROD = @V_DTFABRPROD,
                               NRLOTEFORN = @V_NRLOTEFORN
                         WHERE CDFILIAL   = @V_CDFILIDESTTRD
                           AND NRLOTEESTQ = @V_NRLOTEESTQ
                           AND NRSUBLOTE  = @V_NRSUBLOTE
                           AND CDPRODUTO  = @V_CDPRODUTO;
                     END;

                     INSERT INTO ITEMPRODUTO
                        (CDFILIAL,   NRLANCTONF,   NRSEQITPROD,  CDPRODUTO,  CDPRODEMIS,
                         DSPRODEMIS, IDATUVRESTOQ, QTITEMPROD,   VRUNITITEM, VRDESCITEM,
                         VRTOTAITEM, VRCONTITEM,   IDCONFORITEM, VRBRUTITEM, CDFILIMOVI,
                         CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE)
                     VALUES
                        (@P_CDFILIPROC, @V_PRXNRLANCNF, @V_NRSEQITPROD, @V_CDPRODUTO, @V_CDPRODEMIS,
                         @V_DSPRODEMIS, 'S', @V_QTITEMPROD, @V_VRUNITITEM, @V_VRDESCITEM,
                         @V_VRTOTAITEM, 0, 'S', @V_VRLIQUITEM, @V_CDFILIDESTTRD,
                         @V_ALMOXARIFE, @V_LOCALESTOQ, @V_NRLOTEESTQ, @V_NRSUBLOTE);
                  END
                  ELSE BEGIN
                     INSERT INTO ITEMPRODUTO
                        (CDFILIAL,   NRLANCTONF,   NRSEQITPROD,  CDPRODUTO,  CDPRODEMIS,
                         DSPRODEMIS, IDATUVRESTOQ, QTITEMPROD,   VRUNITITEM, VRDESCITEM,
                         VRTOTAITEM, VRCONTITEM,   IDCONFORITEM, VRBRUTITEM, CDFILIMOVI)
                     VALUES
                        (@P_CDFILIPROC, @V_PRXNRLANCNF, @V_NRSEQITPROD, @V_CDPRODUTO, @V_CDPRODEMIS,
                         @V_DSPRODEMIS, 'S', @V_QTITEMPROD, @V_VRUNITITEM, @V_VRDESCITEM,
                         @V_VRTOTAITEM, 0, 'S', @V_VRLIQUITEM, @V_CDFILIDESTTRD);
                  END;

                  FETCH NEXT FROM C_ITEMPRODUTOENTRADA INTO
                  @V_NRSEQITPROD, @V_CDPRODUTO,  @V_CDPRODEMIS, @V_DSPRODEMIS,
                  @V_QTITEMPROD,  @V_VRUNITITEM, @V_VRDESCITEM, @V_VRTOTAITEM,
                  @V_VRCONTITEM,  @V_VRBRUTITEM, @V_VRLIQUITEM, @V_NRLOTEESTQ,
                  @V_NRSUBLOTE,   @V_DTVALILOTE, @V_DTFABRPROD, @V_NRLOTEFORN;

               END;
               CLOSE C_ITEMPRODUTOENTRADA;
               DEALLOCATE C_ITEMPRODUTOENTRADA;
            END
            ELSE BEGIN

               DECLARE C_ITEMPRODUTO CURSOR FOR
               SELECT I.NRSEQITPROD, I.CDPRODUTO,  I.CDPRODEMIS, I.DSPRODEMIS, I.QTITEMPROD,
                      I.VRUNITITEM,  I.VRDESCITEM, I.VRTOTAITEM, I.VRCONTITEM, I.VRBRUTITEM,
                      (I.VRTOTAITEM - I.VRDESCITEM) AS VRLIQUITEM,  I.NRLOTEESTQ, I.NRSUBLOTE,
                      L.DTVALILOTE, L.DTFABRPROD, L.NRLOTEFORN
                 FROM ITEMPRODUTO I LEFT JOIN LOTE L ON (I.CDFILIMOVI = L.CDFILIAL)   AND
                                                        (I.NRLOTEESTQ = L.NRLOTEESTQ) AND
                                                        (I.NRSUBLOTE  = L.NRSUBLOTE)  AND
                                                        (I.CDPRODMOVI = L.CDPRODUTO)
                WHERE I.CDFILIAL   = @P_CDFILIAL
                  AND I.NRLANCTONF = @P_NRLANCTONF
               ORDER BY I.NRSEQITPROD;

               OPEN C_ITEMPRODUTO;

               FETCH NEXT FROM C_ITEMPRODUTO INTO
               @V_NRSEQITPROD, @V_CDPRODUTO,  @V_CDPRODEMIS, @V_DSPRODEMIS,
               @V_QTITEMPROD,  @V_VRUNITITEM, @V_VRDESCITEM, @V_VRTOTAITEM,
               @V_VRCONTITEM,  @V_VRBRUTITEM, @V_VRLIQUITEM, @V_NRLOTEESTQ,
               @V_NRSUBLOTE,   @V_DTVALILOTE, @V_DTFABRPROD, @V_NRLOTEFORN;

               WHILE (@@FETCH_STATUS = 0) BEGIN

                  SELECT @V_IDCTRLESTQ = ISNULL(MAX(IDCTRLESTQ),'S'),
                         @V_IDUTILLOTE = ISNULL(MAX(IDUTILLOTE), 'N'),
                         @V_DSNUMELOTE =  MAX(DSNUMELOTE)
                  FROM PARAMFILIAL
                  WHERE CDFILIAL = @V_CDFILIORIGTRD;

                  SELECT @V_IDATUESTTPOP = ISNULL(IDATUESTTPOP, 'S')
                    FROM TIPOOPERAC
                   WHERE CDTIPOOPER   = @V_CDTIPOOPERTRD
                     AND IDENTRSAIDOP = @V_IDENTRSAIDTRD;

                  IF @V_IDUTILLOTE = 'S' BEGIN
                     SELECT @V_IDCNTRESTOQ = ISNULL(MAX(IDCNTRESTOQ), 'S'),
                            @V_IDUTILLOTE  = ISNULL(MAX(IDUTCTRLLOTE), 'S')
                       FROM PRODFILI
                      WHERE CDFILIAL  = @V_CDFILIORIGTRD
                        AND CDPRODUTO = @V_CDPRODUTO;
                  END
                  ELSE BEGIN
                     SELECT @V_IDCNTRESTOQ = ISNULL(MAX(IDCNTRESTOQ), 'S'),
                            @V_IDUTILLOTE = 'N'
                       FROM PRODFILI
                      WHERE CDFILIAL  = @V_CDFILIORIGTRD
                        AND CDPRODUTO = @V_CDPRODUTO;
                  END;

                  IF @V_IDCTRLESTQ = 'S' AND @V_IDATUESTTPOP = 'S' AND @V_IDCNTRESTOQ = 'S' BEGIN
                     EXEC LOCALESTOQUE_PADRAO @V_CDFILIORIGTRD, @V_CDPRODUTO, @P_CDALMOXARIFE = @V_CDALMOXARIFE OUTPUT, @P_CDLOCALESTOQ = @V_CDLOCALESTOQ OUTPUT;

                     IF (@V_CDALMOXARTRD = 'P') BEGIN
                        SET @V_ALMOXARIFE = @V_CDALMOXARIFE;
                     END
                     ELSE BEGIN
                        SET @V_ALMOXARIFE = @V_CDALMOXARTRD;
                     END;

                     IF (@V_CDLOCESTQTRD = 'P') BEGIN
                        SET @V_LOCALESTOQ = @V_CDLOCALESTOQ;
                     END
                     ELSE BEGIN
                        SET @V_LOCALESTOQ = @V_CDLOCESTQTRD;
                     END;

                     IF (@V_IDUTILLOTE = 'S') BEGIN
                        IF (@V_NRLOTEESTQ IS NULL) OR (@V_NRLOTEESTQ = ' ') BEGIN
                           EXEC CONSULTA_LOTE 'S', @V_CDFILIORIGTRD, @V_ALMOXARIFE, @V_LOCALESTOQ, @V_CDPRODUTO, @V_NRLOTEESTQ, @V_NRSUBLOTE;
                        END;
                     END
                     ELSE BEGIN
                        SET @V_NRLOTEESTQ = ' ';
                        SET @V_NRSUBLOTE  = ' ';
                     END;

                     INSERT INTO LOTE
                     (CDFILIAL, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO, IDSTATLOTE, DTENTRLOTE)
                     (SELECT @V_CDFILIORIGTRD, @V_NRLOTEESTQ, @V_NRSUBLOTE,
                             @V_CDPRODUTO, 'L', GETDATE()
                      FROM PARAMGERAL
                      WHERE
                      NOT EXISTS
                      (SELECT CDFILIAL, NRLOTEESTQ, NRSUBLOTE, @V_CDPRODUTO, 'L', GETDATE()
                      FROM LOTE
                      WHERE  CDFILIAL   = @V_CDFILIORIGTRD AND
                             NRLOTEESTQ = @V_NRLOTEESTQ    AND
                             NRSUBLOTE  = @V_NRSUBLOTE     AND
                             CDPRODUTO  = @V_CDPRODUTO));

                      IF @V_NRLOTEESTQ <> ' ' BEGIN
                         UPDATE LOTE
                            SET DTVALILOTE = @V_DTVALILOTE,
                                DTFABRPROD = @V_DTFABRPROD,
                                NRLOTEFORN = @V_NRLOTEFORN
                          WHERE CDFILIAL   = @V_CDFILIDESTTRD
                            AND NRLOTEESTQ = @V_NRLOTEESTQ
                            AND NRSUBLOTE  = @V_NRSUBLOTE
                            AND CDPRODUTO  = @V_CDPRODUTO;
                      END;

                      INSERT INTO ITEMPRODUTO
                        (CDFILIAL,   NRLANCTONF,   NRSEQITPROD,  CDPRODUTO,  CDPRODEMIS,
                         DSPRODEMIS, IDATUVRESTOQ, QTITEMPROD,   VRUNITITEM, VRDESCITEM,
                         VRTOTAITEM, VRCONTITEM,   IDCONFORITEM, VRBRUTITEM, CDFILIMOVI,
                         CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE)
                      VALUES
                        (@P_CDFILIPROC, @V_PRXNRLANCNF, @V_NRSEQITPROD, @V_CDPRODUTO, @V_CDPRODEMIS,
                         @V_DSPRODEMIS, 'S', @V_QTITEMPROD, @V_VRUNITITEM, @V_VRDESCITEM,
                         @V_VRTOTAITEM, 0, 'S', @V_VRLIQUITEM, @V_CDFILIORIGTRD,
                         @V_ALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ, @V_NRSUBLOTE);
                  END
                  ELSE BEGIN
                      INSERT INTO ITEMPRODUTO
                        (CDFILIAL,   NRLANCTONF,   NRSEQITPROD,  CDPRODUTO,  CDPRODEMIS,
                         DSPRODEMIS, IDATUVRESTOQ, QTITEMPROD,   VRUNITITEM, VRDESCITEM,
                         VRTOTAITEM, VRCONTITEM,   IDCONFORITEM, VRBRUTITEM, CDFILIMOVI)
                      VALUES
                        (@P_CDFILIPROC, @V_PRXNRLANCNF, @V_NRSEQITPROD, @V_CDPRODUTO, @V_CDPRODEMIS,
                         @V_DSPRODEMIS, 'S', @V_QTITEMPROD, @V_VRUNITITEM, @V_VRDESCITEM,
                         @V_VRTOTAITEM, 0, 'S', @V_VRLIQUITEM, @V_CDFILIORIGTRD);
                  END;

                  FETCH NEXT FROM C_ITEMPRODUTO INTO
                  @V_NRSEQITPROD, @V_CDPRODUTO,  @V_CDPRODEMIS, @V_DSPRODEMIS,
                  @V_QTITEMPROD,  @V_VRUNITITEM, @V_VRDESCITEM, @V_VRTOTAITEM,
                  @V_VRCONTITEM,  @V_VRBRUTITEM, @V_VRLIQUITEM, @V_NRLOTEESTQ,
                  @V_NRSUBLOTE,   @V_DTVALILOTE, @V_DTFABRPROD, @V_NRLOTEFORN;
               END;
               CLOSE C_ITEMPRODUTO;
               DEALLOCATE C_ITEMPRODUTO;
            END;                 

            SET @V_SUGREGSTENTR  = 'S';
            SET @V_CDENCARGOST   = NULL;
            SET @V_T_VRIMPICMSST = 0;

            IF (@V_IDENTRSAIDTRD = 'E') BEGIN  
               BEGIN TRY
                  SELECT @V_SUGREGSTENTR = ISNULL(MAX(IE.IDSUGREGSTENTR),'S'), @V_CDENCARGOST = MAX(IE.CDENCARGOST)
                    FROM NOTAFISCAL NF INNER JOIN INSCRESTAD IE ON NF.CDEMPRESA  = IE.CDEMPRESA
                                                               AND NF.CDINSCESTA = IE.CDINSCESTA
                   WHERE NF.CDFILIAL   = @P_CDFILIPROC
                     AND NF.NRLANCTONF = @V_PRXNRLANCNF;
               END TRY
               BEGIN CATCH
                  SET @V_SUGREGSTENTR = 'S';
                  SET @V_CDENCARGOST  = NULL;
               END CATCH;

               DECLARE C_ITEMPROIMPOS CURSOR FOR
               SELECT DISTINCT I.NRSEQITPROD, I.CDIMPOSTO, I.VRALIQITEM, I.VRIMPOSTOIT, I.VRPERREDBCIT, II.CDIMPOSTONFE
                 FROM ITEMPROIMPOS I INNER JOIN IMPOSTO II ON I.CDIMPOSTO = II.CDIMPOSTO
                WHERE I.CDFILIAL     = @P_CDFILIAL     AND
                      I.NRLANCTONF   = @P_NRLANCTONF   AND
                      I.NRITPROIMPOS = '1'
                ORDER BY I.NRSEQITPROD, I.CDIMPOSTO;

               OPEN C_ITEMPROIMPOS;

               FETCH NEXT FROM C_ITEMPROIMPOS INTO @V_NRSEQITPROD, @V_CDIMPOSTO, @V_VRALIQITEM, @V_VRIMPOSTOIT, @V_VRPERREDBCIT, @V_CDIMPOSTONFE;

               WHILE (@@FETCH_STATUS = 0) BEGIN 
                  IF (@V_CDIMPOSTONFE = '80') AND (@V_SUGREGSTENTR = 'N') AND (@V_CDENCARGOST IS NULL) BEGIN
                     UPDATE ITEMPRODUTO
                        SET VRUNITITEM = ((@V_VRIMPOSTOIT/QTITEMPROD)+VRUNITITEM),
                            VRTOTAITEM = (VRTOTAITEM+@V_VRIMPOSTOIT),
                            VRBRUTITEM = (VRBRUTITEM+@V_VRIMPOSTOIT)
                      WHERE CDFILIAL    = @P_CDFILIPROC
                        AND NRLANCTONF  = @V_PRXNRLANCNF
                        AND NRSEQITPROD = @V_NRSEQITPROD;
                  END
                  ELSE BEGIN
                     IF (@V_CDIMPOSTONFE = '80') AND (@V_SUGREGSTENTR = 'N') BEGIN
                        SET @V_T_VRIMPICMSST = @V_T_VRIMPICMSST+@V_VRIMPOSTOIT;

                        UPDATE ITEMPRODUTO
                           SET VRICMSSTITORIG = @V_VRIMPOSTOIT
                         WHERE CDFILIAL    = @P_CDFILIPROC
                           AND NRLANCTONF  = @V_PRXNRLANCNF
                           AND NRSEQITPROD = @V_NRSEQITPROD;
                     END
                     ELSE BEGIN
                        INSERT INTO TRABITPROIMPOS
                           (CDFILIMPOIT,  NRLANCIMPOIT,  NRSEQIMPOIT,   CDIMPOSTOIT,
                            VRCONTIMPOIT, VRREDBCIMPOIT, VRBCALCIMPOIT, VRALIQIMPOIT,
                            VRPDEDIMPOIT, VRIMPOSIT,     NRSEQITPRO)
                        VALUES
                           (@P_CDFILIPROC, @V_PRXNRLANCNF, @V_NRSEQITPROD, @V_CDIMPOSTO,
                            0, @V_VRPERREDBCIT, 0, @V_VRALIQITEM,
                            0, @V_VRIMPOSTOIT, '1');
                     END;
                  END;

                  FETCH NEXT FROM C_ITEMPROIMPOS INTO @V_NRSEQITPROD, @V_CDIMPOSTO, @V_VRALIQITEM, @V_VRIMPOSTOIT, @V_VRPERREDBCIT, @V_CDIMPOSTONFE;
               END;
               CLOSE C_ITEMPROIMPOS;
               DEALLOCATE C_ITEMPROIMPOS;

               DECLARE C_IMPOSNFTOT CURSOR FOR
               SELECT DISTINCT I.CDIMPOSTO, I.VRTOTIMPONF, II.CDIMPOSTONFE
               FROM IMPOSNFTOT I INNER JOIN IMPOSTO II ON I.CDIMPOSTO = II.CDIMPOSTO
               WHERE I.CDFILIAL     = @P_CDFILIAL     AND
                     I.NRLANCTONF   = @P_NRLANCTONF
               ORDER BY I.CDIMPOSTO;

               OPEN C_IMPOSNFTOT;

               FETCH NEXT FROM C_IMPOSNFTOT INTO @V_CDIMPOSTO, @V_VRTOTIMPONF, @V_CDIMPOSTONFE;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  IF NOT ((@V_CDIMPOSTONFE = '80') AND (@V_SUGREGSTENTR = 'N')) BEGIN
                     INSERT INTO TRABIMPOSNFTOT
                        (CDFILIMPTOT, NRLANCIMPTOT, CDIMPOSTOT,
                         VRIMPOSTOT,  VRBCALIMPTOT)
                     VALUES
                        (@P_CDFILIPROC,  @V_PRXNRLANCNF, @V_CDIMPOSTO,
                         @V_VRTOTIMPONF, 0);
                  END;

                  FETCH NEXT FROM C_IMPOSNFTOT INTO @V_CDIMPOSTO, @V_VRTOTIMPONF, @V_CDIMPOSTONFE;
               END;
               CLOSE C_IMPOSNFTOT;
               DEALLOCATE C_IMPOSNFTOT;
            END;

            DECLARE C_ITEMENCARGO CURSOR FOR
            SELECT CDENCARGO, VRITEMENCA
            FROM ITEMENCARGO
            WHERE CDFILIAL    = @P_CDFILIAL AND
                  NRLANCTONF  = @P_NRLANCTONF
            ORDER BY CDENCARGO;

            OPEN C_ITEMENCARGO;

            FETCH NEXT FROM C_ITEMENCARGO INTO @V_CDENCARGO, @V_VRITEMENCA;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               IF @V_CDENCARGOST = @V_CDENCARGO BEGIN                            
                  INSERT INTO ITEMENCARGO
                     (CDFILIAL, NRLANCTONF, CDENCARGO, VRITEMENCA)
                  VALUES
                     (@P_CDFILIPROC, @V_PRXNRLANCNF, @V_CDENCARGO, @V_VRITEMENCA+@V_T_VRIMPICMSST);
               END
               ELSE BEGIN
                  INSERT INTO ITEMENCARGO
                     (CDFILIAL, NRLANCTONF, CDENCARGO, VRITEMENCA)
                  VALUES
                     (@P_CDFILIPROC, @V_PRXNRLANCNF, @V_CDENCARGO, @V_VRITEMENCA);
               END;
               
               FETCH NEXT FROM C_ITEMENCARGO INTO @V_CDENCARGO, @V_VRITEMENCA;
            END;

            CLOSE C_ITEMENCARGO;
            DEALLOCATE C_ITEMENCARGO;

            DECLARE C_DADOSADIC CURSOR FOR
            SELECT NRDADOADIC, CDMENSAGEM, DSDADOADIC
            FROM DADOSADIC
            WHERE CDFILIAL    = @P_CDFILIAL AND
                  NRLANCTONF  = @P_NRLANCTONF
            ORDER BY NRDADOADIC;

            OPEN C_DADOSADIC;

            FETCH NEXT FROM C_DADOSADIC INTO @V_NRDADOADIC, @V_CDMENSAGEM, @V_DSDADOADIC;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               INSERT INTO DADOSADIC
                  (CDFILIAL, NRLANCTONF, NRDADOADIC, CDMENSAGEM, DSDADOADIC)
               VALUES
                  (@P_CDFILIPROC, @V_PRXNRLANCNF, @V_NRDADOADIC, @V_CDMENSAGEM, @V_DSDADOADIC);

               FETCH NEXT FROM C_DADOSADIC INTO @V_NRDADOADIC, @V_CDMENSAGEM, @V_DSDADOADIC;
            END;
            CLOSE C_DADOSADIC;
            DEALLOCATE C_DADOSADIC;

            IF (@V_IDENTRSAIDTRD = 'E') BEGIN
               SELECT @V_IDCTRLESTQ = ISNULL(MAX(IDCTRLESTQ),'S')
                 FROM PARAMFILIAL
                WHERE CDFILIAL = @V_CDFILIDESTTRD;

               SELECT @V_IDATUESTTPOP = ISNULL(IDATUESTTPOP, 'S')
                 FROM TIPOOPERAC
                WHERE CDTIPOOPER   = @V_CDTIPOOPERTRD
                  AND IDENTRSAIDOP = @V_IDENTRSAIDTRD;

               IF @V_IDCTRLESTQ = 'S' AND @V_IDATUESTTPOP = 'S' BEGIN
                  IF ISNULL(@P_IDDOCFATUR, 'N') <> 'S' BEGIN
                     EXEC IMPOSTO_ENTRADA @V_CDEMPRESA, @V_CDINSCESTA, @V_CDTIPOOPERTRD, '', @P_CDFILIPROC,
                                          @V_PRXNRLANCNF, @V_DTENTRSAID, @V_PRXNRLANCEST, 'E', @P_VRNOTAFISC = @V_VRLANCAMENTO OUTPUT;
                  END
                  ELSE BEGIN
                     EXEC IMPOSTO_ENTRADA @V_CDEMPRESA, @V_CDINSCESTA, @V_CDTIPOOPERTRD, '', @P_CDFILIPROC,
                                          @V_PRXNRLANCNF, @V_DTENTRSAID, '', 'E', @P_VRNOTAFISC = @V_VRLANCAMENTO OUTPUT;
                  END;
               END
               ELSE BEGIN
                  EXEC IMPOSTO_ENTRADA @V_CDEMPRESA, @V_CDINSCESTA, @V_CDTIPOOPERTRD, '', @P_CDFILIPROC,
                                       @V_PRXNRLANCNF, @V_DTENTRSAID, '', 'E', @P_VRNOTAFISC = @V_VRLANCAMENTO OUTPUT;
               END;
            END
            ELSE BEGIN
               SELECT @V_IDCTRLESTQ = ISNULL(MAX(IDCTRLESTQ),'S')
                 FROM PARAMFILIAL
                WHERE CDFILIAL = @V_CDFILIORIGTRD;

               SELECT @V_IDATUESTTPOP = ISNULL(IDATUESTTPOP, 'S')
                 FROM TIPOOPERAC
                WHERE CDTIPOOPER   = @V_CDTIPOOPERTRD
                  AND IDENTRSAIDOP = @V_IDENTRSAIDTRD;

               IF @V_IDCTRLESTQ = 'S' AND @V_IDATUESTTPOP = 'S' BEGIN
                  IF ISNULL(@P_IDDOCFATUR, 'N') <> 'S' BEGIN
                     EXEC IMPOSTO_SAIDA @V_CDEMPRESA, @V_CDINSCESTA, @V_CDTIPOOPERTRD, '', @P_CDFILIPROC,
                                        @V_PRXNRLANCNF, @V_DTENTRSAID, @V_PRXNRLANCEST, NULL, @P_VRNOTAFISC = @V_VRLANCAMENTO OUTPUT;
                  END
                  ELSE BEGIN
                     EXEC IMPOSTO_SAIDA @V_CDEMPRESA, @V_CDINSCESTA, @V_CDTIPOOPERTRD, '', @P_CDFILIPROC,
                                        @V_PRXNRLANCNF, @V_DTENTRSAID, '', NULL, @P_VRNOTAFISC = @V_VRLANCAMENTO OUTPUT;
                  END;
               END
               ELSE BEGIN
                  EXEC IMPOSTO_SAIDA @V_CDEMPRESA, @V_CDINSCESTA, @V_CDTIPOOPERTRD, '', @P_CDFILIPROC,
                                     @V_PRXNRLANCNF, @V_DTENTRSAID, NULL, NULL, @P_VRNOTAFISC = @V_VRLANCAMENTO OUTPUT;
               END;
            END;

            /* ATUALIZAO DO LTIMO CUSTO E VALOR DOS IMPOSTOS */
            IF @V_IDENTRSAIDTRD = 'E' BEGIN
               EXEC GRAVA_IMPOSTO @P_CDFILIPROC, @V_PRXNRLANCNF;
               EXEC CUSTO_LIQUIDO @P_CDFILIPROC, @V_PRXNRLANCEST, @V_VRPRODUTOS;
            END;

            SET @V_PRXNRLANCNF  = RIGHT(REPLICATE('0',10) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_PRXNRLANCNF) + 1)),10);
            SET @V_PRXNRLANCEST = RIGHT(REPLICATE('0',10) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_PRXNRLANCEST) + 1)),10);
            SET @V_REPLICACAOOK = 1;
         END;
         FETCH NEXT FROM C_TRABREPLICDOC INTO @V_CDFILIORIGTRD, @V_CDFILIDESTTRD,
                                              @V_IDENTRSAIDTRD, @V_CDTIPOOPERTRD,
                                              @V_CDSERIETRD, @V_CDALMOXARTRD, @V_CDLOCESTQTRD;
      END;
      CLOSE C_TRABREPLICDOC;
      DEALLOCATE C_TRABREPLICDOC;

      IF @V_REPLICACAOOK = 1 BEGIN
         UPDATE NOTAFISCAL
            SET IDNFUTILREPLIC = 'S'
          WHERE CDFILIAL   = @P_CDFILIAL AND
                NRLANCTONF = @P_NRLANCTONF;
      END;

      FETCH NEXT FROM C_NOTAFISCAL1 INTO @V_CDEMPRESA,   @V_CDINSCESTA,   @V_CDINSCMUNI,   @V_CDFORNECED,
                                         @V_CDCLIENTE,    @V_NRNOTAFISC,   @V_DTEMISSAO,    @V_DTENTRSAID,
                                         @V_VRPRODUTOS,   @V_VRNOTAFISC,   @V_NRPLACAVEIC,  @V_SGUFVEIC,
                                         @V_IDPGTOFRETE,  @V_DSQTDEVOLU,   @V_DSESPECVOLU,  @V_DSMARCAVOLU,
                                         @V_DSNUMEVOLU,   @V_VRPBRUTOVOLU, @V_VRPLIQUVOLU,  @V_IDENTRSAIDOP,
                                         @V_CDTIPOOPER,   @V_CDSERIE,      @V_IDTPIJURTRAN, @V_NRINSJURTRAN,
                                         @V_CDSERIEENTR,  @V_CDFILIRECE,   @V_CDMODDOCFISC;
   END;
   CLOSE C_NOTAFISCAL1;
   DEALLOCATE C_NOTAFISCAL1;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'REPLICACAO_DOCUMENTOS','6.49.052';
GO
