
DECLARE
   V_JOB NUMBER;
   V_EXIST NUMBER;
   V_STATUS VARCHAR2(7);
BEGIN
   SELECT COUNT(1), MAX(STATUS) 
      INTO V_EXIST, V_STATUS
   FROM USER_OBJECTS
   WHERE OBJECT_NAME = 'CONVERTE_FOTOPRATO_LONG_RAW';

    -- Apagar formato antigo de JOB
    FOR C_JOBS IN (SELECT JOB
                  FROM ALL_JOBS
                 WHERE WHAT LIKE '%CONVERTE_FOTOPRATO_LONG_RAW%') LOOP
     DBMS_JOB.REMOVE(C_JOBS.JOB);
    END LOOP;
    --Verifica se o job ja existe
    SELECT COUNT(*) INTO V_JOB
    FROM USER_SCHEDULER_JOBS
    WHERE JOB_NAME = 'JOB_FOTOPRATO_LRAW';
    
    IF V_JOB > 0 THEN
     DBMS_SCHEDULER.DROP_JOB(JOB_NAME => 'JOB_FOTOPRATO_LRAW');
    END IF;
      
   IF V_EXIST > 0 AND V_STATUS = 'VALID' THEN
      DBMS_SCHEDULER.CREATE_JOB (
      JOB_NAME => 'JOB_FOTOPRATO_LRAW',
      JOB_TYPE => 'PLSQL_BLOCK',
      JOB_ACTION => 'BEGIN CONVERTE_FOTOPRATO_LONG_RAW; COMMIT; END;',
      START_DATE => systimestamp,
      repeat_interval => 'FREQ=SECONDLY;INTERVAL=30',
      JOB_CLASS => '"DEFAULT_JOB_CLASS"',
      ENABLED => TRUE,
      AUTO_DROP => FALSE,
      COMMENTS => '');

      COMMIT;

   ELSE
      EXECUTE IMMEDIATE 'DROP PROCEDURE CONVERTE_FOTOPRATO_LONG_RAW';
   END IF;
END; 
/