var InventarioRotativo_Service = function(localStorageEngine, restEngine, InventarioRotativo_Repository, ZHPromise) {

	this.verificaInvePendente = function(cdfilial) {
        var filter = [{
            "name": "P_CDFILIAL",
            "operator": "=",
            "value": cdfilial
        }];
        return localStorageEngine.download('/verificaInvePend',filter);
    };

    this.save = function(rowsToSave, utLote) {
    	if (utLote) {
    	    return InventarioRotativo_Repository.saveInverotalote(rowsToSave);
        }
    	else {
    	    return InventarioRotativo_Repository.saveInverota(rowsToSave);
        }
    };

    this.getOperadorLogado = function() {
         var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];

        return localStorageEngine.download("peblib#/crud/operador", filter);
    };

    this.atualizaInventarioRotativo = function(filter) {
        return InventarioRotativo_Repository.atualizaInverota(filter);
    };

    /*
     *  Função para verificar se há inventário pendente.
     *  Como há um preDispatch no backend, o retorno cairá num callback
     *  de erro se houver inventário rotativo pendente, devido a uma
     *  exception que é lançada. Se não houver inventário rotativo, o retorno
     *  será no callback de sucesso.
     */
    this.checkInventarioPendente = function() {
        var deferred = ZHPromise.defer();
        InventarioRotativo_Repository.checkInventarioPendente().then(function(response) {
            // Verifica se realmente entrou na função de verificação e
            // retornou o dataset "inventario_valido".
            if (response.dataset && response.dataset.inventario_valido) {
                deferred.resolve(true);
            }
            else {
                deferred.reject(response);
            }
        }, function(error) {
            // Verifica se o erro tratado é a exceção de inventário rotativo pendente
            if (error && Util.isObject(error.data) && error.data.error === "Exception: Inventário Rotativo Pendente") {
                deferred.resolve(false);
            }
            else {
                deferred.reject(error);
            }
        });
        return deferred;
    };

};

Configuration(function(ContextRegister) {
    ContextRegister.register('InventarioRotativo_Service', InventarioRotativo_Service);
});